#version 330 compatibility

layout(triangles) in;
layout(triangle_strip, max_vertices = 6) out;

in vec4 vcolor[];
in vec4 vtexcoord[];
in vec3 vnormal[];
in vec3 vrawNormal[];
in vec4 vviewPos[];
in float vmaterialIDs[];
in vec4 cmXnHEHLYJ[];
in vec4 kZhYLMjNQq[];
in float zYudVgYJNi[];
in vec2 SJAIzAnwSc[];
in float lKRWNuACIi[];
in float vsVqcfOoSrb[];
in float vMCEntity[];

out vec4 color;
out vec4 texcoord;
out vec3 normal;
out vec3 rawNormal;
out vec4 viewPos;
out float materialIDs;
out float DCPUZWJAWq;
out vec2 vFsmmLxuUQ;
out float nqbOYzWFJP;
out float sVqcfOoSrb;
out float mcEntity;


void main()
{
	int i;
	vec4 vertex;

	//Standard shadow pos
	for (i = 0; i < 3; i++)
	{
		vertex = gl_in[1].gl_Position;

		//...
		vertex = kZhYLMjNQq[i];

		gl_Position = vertex;

		//copy varying here
		color = vcolor[i];
		texcoord = vtexcoord[i];
		normal = vnormal[i];
		rawNormal = vrawNormal[i];
		viewPos = vviewPos[i];
		materialIDs = vmaterialIDs[i];
		vFsmmLxuUQ = SJAIzAnwSc[i];
		nqbOYzWFJP = lKRWNuACIi[i];
		sVqcfOoSrb = vsVqcfOoSrb[i];
		mcEntity = vMCEntity[i];
		DCPUZWJAWq = 0.0;

		EmitVertex();
	}
	EndPrimitive();


	//volume pos
	bool valid = true;
	if (zYudVgYJNi[0] > 0.5 || zYudVgYJNi[1] > 0.5 || zYudVgYJNi[2] > 0.5)
	{
		valid = false;
	}

	if (valid)
	{
		if (distance(cmXnHEHLYJ[0].xy, cmXnHEHLYJ[1].xy) > 1.0 / 1024.0 ||
			distance(cmXnHEHLYJ[0].xy, cmXnHEHLYJ[2].xy) > 1.0 / 1024.0 ||
			distance(cmXnHEHLYJ[1].xy, cmXnHEHLYJ[2].xy) > 1.0 / 1024.0)
		{

		}
		else
		{
			for (i = 0; i < 3; i++)
			{
				vertex = gl_in[1].gl_Position;

				//...
				vertex = cmXnHEHLYJ[i];


				gl_Position = vertex;

				//copy varying here
				color = vcolor[i];
				texcoord = vtexcoord[i];
				normal = vnormal[i];
				rawNormal = vrawNormal[i];
				viewPos = vviewPos[i];
				materialIDs = vmaterialIDs[i];
				vFsmmLxuUQ = SJAIzAnwSc[i];
				nqbOYzWFJP = lKRWNuACIi[i];
				sVqcfOoSrb = vsVqcfOoSrb[i];
				mcEntity = vMCEntity[i];
				DCPUZWJAWq = 1.0;


				EmitVertex();
			}
			EndPrimitive();
		}
	}



}